//+------------------------------------------------------------------+
//|                       ZigZag Channels                            |
//|                                              ZigZag_Channels.mq4 |
//|                                         Developed by Coders Guru |
//|                                            http://www.xpworx.com |
//+------------------------------------------------------------------+
#property copyright "xpworx"
#property link      "http: //www.xpworx.com"
//+------------------------------------------------------------------+
//"Last Modified: 2011.09.20";

// Mod by Big Be, July, Aug 2014 from 3.2HZ  w Horizontal lines...
//+------------------------------------------------------------------+
#property indicator_chart_window
#property indicator_buffers 2
//+------------------------------------------------------------------+
//---- indicator parameters
extern int    ExtDepth       = 12;
extern double ExtDeviation   = 0.5;
extern int    ExtBackstep    = 1;
extern int    BreakPips      = 5;
extern color  UpperBandColor = Red; // Blue;
extern color  LowerBandColor = Blue; // Red;
extern int    back           = 1;
extern bool   AlertOn        = true;
extern string Note0          = "Mods by Big Be Aug 2014 4XLA.org";
//+------------------------------------------------------------------+
double ExtMapBuffer[];
double upperband[];
double lowerband[];
//+------------------------------------------------------------------+
double mPoint = 0.0001;
//+------------------------------------------------------------------+
string pro = "ZigZag v3.2 Channels HZ v3.2";
string ver = "";
string tn;
//+------------------------------------------------------------------+
int deinit()
{
    DeleteObjects();
    return(0);
}
//+------------------------------------------------------------------+
int init()
{
    DeleteObjects();

    Stamp("ver_", pro, 15, 35);
    string copy = "C 2005-2011 XPWORX. All rights reserved.";
    copy = StringSetChar(copy, 0, '');
    Stamp("copyright_", copy, 15, 50);

    mPoint = GetPoint();

    IndicatorBuffers(3);

    SetIndexBuffer(0, upperband);
    SetIndexBuffer(1, lowerband);
    SetIndexBuffer(2, ExtMapBuffer);

    SetIndexLabel(0, "Upper band  ZZ Channel");
    SetIndexLabel(1, "Lower band");

    SetIndexStyle(0, DRAW_NONE);
    SetIndexStyle(1, DRAW_NONE);
    SetIndexStyle(2, DRAW_NONE);

    SetIndexDrawBegin(0, 300);

    return(0);
}
int LastZZ = 0;
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
{
    DrawTrends();

    for (int i = 0; i < 50; i++)
    {
        upperband[i] = ObjectGetValueByShift("uptrend_", i);
        lowerband[i] = ObjectGetValueByShift("dntrend_", i);
    }

    if (AlertOn)
    {
        if (Close[0] > upperband[0] + BreakPips * mPoint && Open[0] < upperband[0])
            AlertOnce(Symbol() + ": " + PeriodToText() + "  -  Buy Signal / " + tn, 0);

        if (Close[0] < lowerband[0] - BreakPips * mPoint && Open[0] > lowerband[0])
            AlertOnce(Symbol() + ": " + PeriodToText() + "  -  Sell Signal / " + tn, 1);
    }

    TrendName();

    return(0);
}


double GetPoint(string symbol = "")
{
    if (symbol == "" || symbol == Symbol())
    {
        if (Point == 0.00001)
            return(0.0001);
        else if (Point == 0.001)
            return(0.01);
        else
            return(Point);
    }
    else
    {
        RefreshRates();
        double tPoint = MarketInfo(symbol, MODE_POINT);
        if (tPoint == 0.00001)
            return(0.0001);
        else if (tPoint == 0.001)
            return(0.01);
        else
            return(tPoint);
    }
}

    double temp  = 0;
    int    count = 0;
    double p1, p2, p3, p4;
    int    b1, b2, b3, b4;
    
    double p5; int b5;
    
void DrawTrends()   // Every tick
{
    bool   up_exist = false;
    bool   dn_exist = false;
    string up_name  = "uptrend_";
    string dn_name  = "dntrend_";
    string up_horiz = "uphoriz_";
    string dn_horiz = "dnhoriz_";


    GetZZpoints();
    
    for (int cnt = ObjectsTotal(); cnt >= 0; cnt--)
    {
        if (StringFind(ObjectName(cnt), up_name, 0) > -1)
            up_exist = true;
        if (StringFind(ObjectName(cnt), dn_name, 0) > -1)
            dn_exist = true;                                        // "dntrend_"
    }

    // Comment(price1," : ",price2," : ",price3," : ",price4,"\n",bar1," : ",bar2," : ",bar3," : ",bar4, " LastZZ ",LastZZ);
     Comment(p1," : ",p2," : ",p3," : ",p4,"\n",b1," : ",b2," : ",b3," : ",b4, " LastZZ ",LastZZ);

    if (p1 > p3) // higher low
        if (p1 < p2)
        {
            if (dn_exist)
            {

                ObjectSet(dn_name, OBJPROP_TIME2, Time[b1]);
                ObjectSet(dn_name, OBJPROP_PRICE2, p1);
                ObjectSet(dn_name, OBJPROP_TIME1, Time[b3]);
                ObjectSet(dn_name, OBJPROP_PRICE1, p3);
                
                ObjectSet(dn_name, OBJPROP_STYLE, STYLE_SOLID);
                ObjectSet(dn_name, OBJPROP_WIDTH, 2);
                ObjectSet(dn_name, OBJPROP_COLOR, LowerBandColor);
            //------------------------------------------------------//
                ObjectSet(dn_horiz, OBJPROP_PRICE1, p2);
                ObjectSet(dn_horiz, OBJPROP_TIME1, Time[b2 + 1]);
                ObjectSet(dn_horiz, OBJPROP_TIME2, Time[b2]);
                ObjectSet(dn_horiz, OBJPROP_PRICE2, p2);
                
                ObjectSet(dn_horiz, OBJPROP_STYLE, STYLE_SOLID);
                ObjectSet(dn_horiz, OBJPROP_WIDTH, 1);
                ObjectSet(dn_horiz, OBJPROP_COLOR, LowerBandColor);
                WindowRedraw();
            }
            else
            {
                ObjectCreate(dn_name, OBJ_TREND, 0, Time[b3], p3, Time[b1], p1);  //****
                ObjectSet(dn_name, OBJPROP_STYLE, STYLE_SOLID);
                ObjectSet(dn_name, OBJPROP_WIDTH, 2);
                ObjectSet(dn_name, OBJPROP_COLOR, LowerBandColor);
           //------------------------------------------------------//
                
                ObjectCreate(dn_horiz, OBJ_TREND, 0, Time[b2 + 1], p2, Time[b2], p2);
                ObjectSet(dn_horiz, OBJPROP_STYLE, STYLE_SOLID);
                ObjectSet(dn_horiz, OBJPROP_WIDTH, 1);
                ObjectSet(dn_horiz, OBJPROP_COLOR, LowerBandColor);
                WindowRedraw();
            }
        }

    if (p3 > p1)
        if (p1 > p2) // lower high
        {
            if (up_exist)
            {
                ObjectSet(up_name, OBJPROP_TIME2, Time[b1]);
                ObjectSet(up_name, OBJPROP_PRICE2, p1);

                ObjectSet(up_name, OBJPROP_PRICE1, p3);
                ObjectSet(up_name, OBJPROP_TIME1, Time[b3]);

                ObjectSet(up_name, OBJPROP_STYLE, STYLE_SOLID);
                ObjectSet(up_name, OBJPROP_WIDTH, 2);
                ObjectSet(up_name, OBJPROP_COLOR, UpperBandColor);
            //------------------------------------------------------//
                ObjectSet(up_horiz, OBJPROP_PRICE1, p2);
                ObjectSet(up_horiz, OBJPROP_TIME1, Time[b2 + 1]);
                ObjectSet(up_horiz, OBJPROP_TIME2, Time[b2]);
                ObjectSet(up_horiz, OBJPROP_PRICE2, p2);
                
                ObjectSet(up_horiz, OBJPROP_STYLE, STYLE_SOLID);
                ObjectSet(up_horiz, OBJPROP_WIDTH, 1);
                ObjectSet(up_horiz, OBJPROP_COLOR, UpperBandColor);

                WindowRedraw();
            }
            else
            {
                ObjectCreate(up_name, OBJ_TREND, 0, Time[b3], p3, Time[b1], p1);

                ObjectSet(up_name, OBJPROP_STYLE, STYLE_SOLID);
                ObjectSet(up_name, OBJPROP_WIDTH, 2);
                ObjectSet(up_name, OBJPROP_COLOR, UpperBandColor);
            //------------------------------------------------------//
                ObjectCreate(up_horiz, OBJ_TREND, 0, Time[b2 + 1], p2, Time[b2], p2);

                ObjectSet(up_horiz, OBJPROP_STYLE, STYLE_SOLID);
                ObjectSet(up_horiz, OBJPROP_WIDTH, 1);
                ObjectSet(up_horiz, OBJPROP_COLOR, UpperBandColor);

                WindowRedraw();
            }
        }
}

void TrendName()
{
    double Price_up_horiz = ObjectGet("uphoriz_", OBJPROP_PRICE1);
    double Price_dn_horiz = ObjectGet("dnhoriz_", OBJPROP_PRICE1);

    tn = "Noisy";
    if (upperband[0] < upperband[10] 
       // && lowerband[0] < lowerband[10]
       && Close[0] < Price_up_horiz
        )
        tn = "Falling trend";
    else    
    if (//upperband[0] > upperband[10] && 
        lowerband[0] > lowerband[10]
        && Close[0] > Price_dn_horiz
        )
        tn = "Rising trend";
        


    //Comment(/*" up_horiz ",uphoriz_,*/" Price_up_horiz ",Price_up_horiz, " Price_dn_horiz ",Price_dn_horiz);
    
    if (upperband[0] < upperband[10] && lowerband[0] > lowerband[10]
        && Close[0] < upperband[0] && Close[0] > lowerband[0])
       // && Close[0] < Price_dn_horiz && Close[0] > Price_up_horiz)
        tn = "Triangle trend";

    Stamp("trend_name_", tn, 15, 70);
}

void GetZZpoints()
{
     temp  = 0; count = 0;
     p1 = 0; p2 = 0; p3 = 0; p4 = 0;
     b1 = 0; b2 = 0; b3 = 0; b4 = 0;
     
     p5 = 0; b5 = 0;

    for (int i = 0; i < 500; i++)
    {
        temp = iCustom(NULL, 0, "ZigZag_Corrected_v3.2", ExtDepth, ExtDeviation, ExtBackstep, 0, i); // Hi/Lo points only
        if (temp != 0)
            count = count + 1;
        if (count == back + 1 && temp != 0)
        {
            p1 = temp; b1 = i;                  // first Hi/Lo point
        }
        if (count == back + 2 && temp != 0)
        {
            p2 = temp; b2 = i;
        }
        if (count == back + 3 && temp != 0)
        {
            p3 = temp; b3 = i;
        }
        if (count == back + 4 && temp != 0)
        {
            p4 = temp; b4 = i;
        }
        
        
        if (count == back + 5 && temp != 0)
        {
            p5 = temp; b5 = i;
        } 
        
        
        if (count == back + 6)
            break;
    }
}

string PeriodToText()
{
    switch (Period())
    {
    case 1:
        return("M1");
        break;
    case 5:
        return("M5");
        break;
    case 15:
        return("M15");
        break;
    case 30:
        return("M30");
        break;
    case 60:
        return("H1");
        break;
    case 240:
        return("H4");
        break;
    case 1440:
        return("D1");
        break;
    case 10080:
        return("W1");
        break;
    case 43200:
        return("MN1");
        break;
    }
}

bool AlertOnce(string msg, int ref)
{
    static int LastAlert[10];

    if (LastAlert[ref] == 0 || LastAlert[ref] < Bars)
    {
        Alert(msg);
        LastAlert[ref] = Bars;
        return(true);
    }
    return(false);
}

void Stamp(string objName, string text, int x, int y)
{
    string Obj  = "Stamp_" + objName;
    int    objs = ObjectsTotal();
    string name;

    for (int cnt = 0; cnt < ObjectsTotal(); cnt++)
    {
        name = ObjectName(cnt);
        if (StringFind(name, Obj, 0) > -1)
        {
            ObjectSet(Obj, OBJPROP_XDISTANCE, x);
            ObjectSet(Obj, OBJPROP_YDISTANCE, y);
            WindowRedraw();
        }
        else
        {
            ObjectCreate(Obj, OBJ_LABEL, 0, 0, 0);
            ObjectSetText(Obj, text, 8, "arial", Orange);
            ObjectSet(Obj, OBJPROP_XDISTANCE, x);
            ObjectSet(Obj, OBJPROP_YDISTANCE, y);
            WindowRedraw();
        }
    }
    if (ObjectsTotal() == 0)
    {
        ObjectCreate(Obj, OBJ_LABEL, 0, 0, 0);
        ObjectSetText(Obj, text, 8, "arial", Orange);
        ObjectSet(Obj, OBJPROP_XDISTANCE, x);
        ObjectSet(Obj, OBJPROP_YDISTANCE, y);
        WindowRedraw();
    }

    return(0);
}

void DeleteObjects()
{
    int    objs = ObjectsTotal();
    string name;
    for (int cnt = ObjectsTotal() - 1; cnt >= 0; cnt--)
    {
        name = ObjectName(cnt);
        // if (StringFind(name,"xpMA",0)>-1) ObjectDelete(name);
        if (StringFind(name, "Stamp_", 0) > -1)
            ObjectDelete(name);
        if (StringFind(name, "trend_name_", 0) > -1)
            ObjectDelete(name);
        if (StringFind(name, "uptrend_", 0) > -1)
            ObjectDelete(name);
        if (StringFind(name, "dntrend_", 0) > -1)
            ObjectDelete(name);
        if (StringFind(name, "uphoriz_", 0) > -1)
            ObjectDelete(name);
        if (StringFind(name, "dnhoriz_", 0) > -1)
            ObjectDelete(name);

        WindowRedraw();
    }
}

